import java.util.Random;

public class Instance_BinPacking extends Instance{
	Random rand;
	double[] sizes, sizes_forecasted;

	public Instance_BinPacking(int seed, int T) {
		super(T);
		sizes = new double[T];
		rand = new Random(seed);
		for(int t = 0; t < T; t++)
			sizes[t] = rand.nextDouble();
		sizes_forecasted = new double[T];
	}
	
	void createForecasts(double gradualLossFactor, int t_current, int lookahead){
		for(int t = 0; t < T; t++)
			if(t < t_current + lookahead)
				sizes_forecasted[t] = sizes[t];
			else{
				sizes_forecasted[t] = sizes[t] + (t - t_current) * (-gradualLossFactor + 2*gradualLossFactor * rand.nextDouble());
				if(sizes_forecasted[t] < 0)
					sizes_forecasted[t] = 0;
				else if(sizes_forecasted[t] > 1)
					sizes_forecasted[t] = 1;
			}
	}
}