import java.util.Arrays;
import java.util.Random;

public class Instance_Scheduling extends Instance{
	Random rand;
	double[] releaseDates, processingTimes, processingTimes_forecasted;

	public Instance_Scheduling(int seed, int T) {
		super(T);
		releaseDates = new double[T];
		processingTimes = new double[T];
		rand = new Random(seed);
		for(int t = 0; t < T; t++){
			releaseDates[t] = rand.nextInt(1000);
			processingTimes[t] = rand.nextInt(100);
		}
		Arrays.sort(releaseDates);
		processingTimes_forecasted = new double[T];
	}
	
	void createForecasts(double gradualLossFactor, int t_current, int lookahead){
		for(int t = 0; t < T; t++)
			if(t < t_current + lookahead)
				processingTimes_forecasted[t] = processingTimes[t];
			else{
				processingTimes_forecasted[t] = processingTimes[t] + (t - t_current) * (-gradualLossFactor + 2*gradualLossFactor * rand.nextDouble());
				if(processingTimes_forecasted[t] < 0)
					processingTimes_forecasted[t] = 0;
				else if(processingTimes_forecasted[t] > 100)
					processingTimes_forecasted[t] = 100;
			}
	}
}